package fucoin;

public abstract class AbstractWallet extends AbstractNode{

	// Constructor
	public AbstractWallet(String name) {
		this.name = name;
	}
    
    // Returns the name of this wallet, e.g. "Lieschen Müller"
    public String getName() {
        return this.name;
    }
	
    // Performs housekeeping operations, e.g. pushes 
    // backedUpNeighbor-entries to other neighbors
    public abstract void leave();
	
    // The amount this wallet currently holds
    public int amount;

    // The name of this wallet (does never change, no 
    // duplicates in network assumed)
    public final String name;
    
    
}
